
#pragma warning(disable:4996)

#include <stdio.h>
#include <windows.h>
#include "resource.h"

#include "../common/pathcat.h"
#include "../config.h"

HINSTANCE _hInstance = 0;

#pragma data_seg("_nigero_shared_data")

HWND _hwnd = 0;
HHOOK hMyKeyboardHook = 0;
HHOOK hMyMouseHook = 0;
bool _hidden = false;
int _mouse_point_x = 0;
int _mouse_point_y = 0;
int _hidden_point_x = 0;
int _hidden_point_y = 0;
bool _suppress_by_left_shift_key = false;
bool _suppress_by_left_ctrl_key = false;
bool _suppress_by_left_alt_key = false;
bool _suppress_by_right_shift_key = false;
bool _suppress_by_right_ctrl_key = false;
bool _suppress_by_right_alt_key = false;
bool _suppress_by_space_key = false;

wchar_t _application_exclusion_file_path[MAX_PATH] = L"";

#pragma data_seg()

char _current_module_path[MAX_PATH] = "";

bool _process_excluded = false;
time_t _process_exclusion_file_time = 0;


#include <sys/stat.h>

bool checkprocess()
{
	struct _stat64i32 st;
	if (_wstat(_application_exclusion_file_path, &st) == 0) {
		if (_process_exclusion_file_time != st.st_mtime) {
			_process_exclusion_file_time = st.st_mtime;
			_process_excluded = false;
			FILE *fp = _wfopen(_application_exclusion_file_path, L"r");
			if (fp) {
				while (!feof(fp)) {
					char tmp[1000];
					if (fgets(tmp, sizeof(tmp), fp)) {
						char const *left = tmp;
						char const *right = tmp + strlen(tmp);
						while (left < right && isspace((unsigned char)right[-1])) {
							right--;
						}
						while (left < right && isspace((unsigned char)left[0])) {
							left++;
						}
						if (left < right) {
							std::string path(left, right);
							if (stricmp(path.c_str(), _current_module_path) == 0) {
								_process_excluded = true;
								break;
							}
						}
					}
				}
				fclose(fp);
			}
		}
	}
	return !_process_excluded;
}


bool get_cursor_pos(int pos, int *px, int *py)
{
	if (pos < 1) return false;
	if (pos > 9) return false;
#if 0
	int x = GetSystemMetrics(SM_CXSCREEN);
	int y = GetSystemMetrics(SM_CYSCREEN);
	switch (pos) {
	case 1:   x = 1;     y -= 2;    break;
	case 2:   x /= 2;    y -= 2;    break;
	case 3:   x -= 2;    y -= 2;    break;
	case 4:   x = 1;     y /= 2;    break;
	case 5:   x /= 2;    y /= 2;    break;
	case 6:   x -= 2;    y /= 2;    break;
	case 7:   x = 1;     y = 1;     break;
	case 8:   x /= 2;    y = 1;     break;
	case 9:   x -= 2;    y = 1;     break;
	}
#else
	RECT rc;
	GetWindowRect(_hwnd, &rc);
	int x = rc.left;
	int y = rc.top;
#endif
	*px = x;
	*py = y;
	return true;
}

void show_cursor()
{
	if (_hidden) {
		SetCursorPos(_mouse_point_x, _mouse_point_y);
		_hidden = false;
	}
}

void hide_cursor()
{
	if (!_hidden && !GetCapture()) {
		if (checkprocess()) {
			POINT pt;
			GetCursorPos(&pt);
			_mouse_point_x = pt.x;
			_mouse_point_y = pt.y;
			if (get_cursor_pos(3, &_hidden_point_x, &_hidden_point_y)) {
				SetCursorPos(_hidden_point_x, _hidden_point_y);
				SendMessage(_hwnd, WM_NULL, 0, 0);
				_hidden = true;
			}
		}
	}
}

LRESULT CALLBACK MyKeyboardHook(int code, WPARAM wParam, LPARAM lParam)
{
	if (code >= 0) {
		if (true) {
			if (GetAsyncKeyState(VK_CONTROL) & 0x8000) {
				if (GetAsyncKeyState(VK_MENU) & 0x8000) {
					int n = 0;
					switch (wParam) {
					case VK_NUMPAD9:	n++;
					case VK_NUMPAD8:	n++;
					case VK_NUMPAD7:	n++;
					case VK_NUMPAD6:	n++;
					case VK_NUMPAD5:	n++;
					case VK_NUMPAD4:	n++;
					case VK_NUMPAD3:	n++;
					case VK_NUMPAD2:	n++;
					case VK_NUMPAD1:	n++;
						break;
					}
					if (n > 0) {
						int x, y;
						get_cursor_pos(n, &x, &y);
						SetCursorPos(x, y);
						return TRUE;
					}
				}
			}
		}
		if (lParam & 0x80000000) {
			// ꂽ
		} else {
			// ꂽ
			if (!_hidden) {
				if (_suppress_by_left_shift_key  && (GetAsyncKeyState(VK_LSHIFT)   & 0x8000)) goto skip;
				if (_suppress_by_left_ctrl_key   && (GetAsyncKeyState(VK_LCONTROL) & 0x8000)) goto skip;
				if (_suppress_by_left_alt_key    && (GetAsyncKeyState(VK_LMENU)    & 0x8000)) goto skip;
				if (_suppress_by_right_shift_key && (GetAsyncKeyState(VK_RSHIFT)   & 0x8000)) goto skip;
				if (_suppress_by_right_ctrl_key  && (GetAsyncKeyState(VK_RCONTROL) & 0x8000)) goto skip;
				if (_suppress_by_right_alt_key   && (GetAsyncKeyState(VK_RMENU)    & 0x8000)) goto skip;
				if (_suppress_by_space_key       && (GetAsyncKeyState(VK_SPACE)    & 0x8000)) goto skip;
				hide_cursor();
skip:;
			}
		}
	}
	return CallNextHookEx(hMyKeyboardHook, code, wParam, lParam);
}

LRESULT CALLBACK MyMouseHook(int code, WPARAM wParam, LPARAM lParam)
{
	MOUSEHOOKSTRUCT *m = (MOUSEHOOKSTRUCT *)lParam;
	if (code >= 0) {
		if (_hidden_point_x != m->pt.x || _hidden_point_y != m->pt.y) {
			show_cursor();

		}
	}

	return CallNextHookEx(hMyMouseHook, code, wParam, lParam);
}

extern "C" __declspec(dllexport) void nigero_setup(HWND hwnd, wchar_t const *appdatadir)
{
	_hwnd = hwnd;
	wcscpy(_application_exclusion_file_path, pathcat(appdatadir, APPLICATION_EXCLUSION_FILE_NAME).c_str());
}

extern "C" __declspec(dllexport) void nigero_enable()
{
	if (!hMyMouseHook)    hMyMouseHook = SetWindowsHookEx(WH_MOUSE, MyMouseHook, _hInstance, 0);
	if (!hMyKeyboardHook) hMyKeyboardHook = SetWindowsHookEx(WH_KEYBOARD, MyKeyboardHook, _hInstance, 0);
}

extern "C" __declspec(dllexport) void nigero_disable()
{
	if (hMyMouseHook)    UnhookWindowsHookEx(hMyMouseHook);
	if (hMyKeyboardHook) UnhookWindowsHookEx(hMyKeyboardHook);
}

extern "C" __declspec(dllexport) void nigero_show()
{
	show_cursor();
}

extern "C" __declspec(dllexport) void nigero_hide()
{
	hide_cursor();
}

extern "C" __declspec(dllexport) bool nigero_is_suppressor(int vk)
{
	switch (vk) {
	case VK_LSHIFT:   return _suppress_by_left_shift_key;
	case VK_LCONTROL: return _suppress_by_left_ctrl_key;
	case VK_LMENU:    return _suppress_by_left_alt_key;
	case VK_RSHIFT:   return _suppress_by_right_shift_key;
	case VK_RCONTROL: return _suppress_by_right_ctrl_key;
	case VK_RMENU:    return _suppress_by_right_alt_key;
	case VK_SPACE:    return _suppress_by_space_key;
	}
	return false;
}

extern "C" __declspec(dllexport) void nigero_set_suppressor(int vk, bool f)
{
	switch (vk) {
	case VK_LSHIFT:     _suppress_by_left_shift_key   = f;   break;
	case VK_LCONTROL:   _suppress_by_left_ctrl_key    = f;   break;
	case VK_LMENU:      _suppress_by_left_alt_key     = f;   break;
	case VK_RSHIFT:     _suppress_by_right_shift_key  = f;   break;
	case VK_RCONTROL:   _suppress_by_right_ctrl_key   = f;   break;
	case VK_RMENU:      _suppress_by_right_alt_key    = f;   break;
	case VK_SPACE:      _suppress_by_space_key        = f;   break;
	}
}


BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	_hInstance = (HINSTANCE)hModule;

	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		GetModuleFileName(0, _current_module_path, sizeof(_current_module_path));
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

