
// MainFrm.cpp : CMainFrame NX̎
//

#include "stdafx.h"
#include "../config.h"
#include "Nigero.h"
#include "MainFrm.h"
#include "NigeroAPI.h"
#include "../common/pathcat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

std::wstring GetMyApplicationDataDir()
{
	std::wstring path;

	wchar_t tmp[MAX_PATH];
	if (SHGetSpecialFolderPath(0, tmp, CSIDL_APPDATA, TRUE)) {
		path = pathcat(tmp, L"Nigero");
	}

	return path;
}

std::wstring GetInitFilePath()
{
	std::wstring dir = GetMyApplicationDataDir();
	return pathcat(dir.c_str(), APPLICATION_INI_FILE_NAME);
}

std::wstring GetExcludeApplicationFilePath()
{
	std::wstring dir = GetMyApplicationDataDir();
	return pathcat(dir.c_str(), APPLICATION_EXCLUSION_FILE_NAME);
}

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wndInvisible = new CInvisibleWnd();
	m_wndInvisible->Create(this);

	std::wstring inipath = GetInitFilePath();

	bool vk_lshift = GetPrivateProfileInt(L"Nigero", L"vk_lshift", 1, inipath.c_str()) != 0;
	bool vk_lcontrol = GetPrivateProfileInt(L"Nigero", L"vk_lcontrol", 1, inipath.c_str()) != 0;
	bool vk_lmenu = GetPrivateProfileInt(L"Nigero", L"vk_lmenu", 1, inipath.c_str()) != 0;
	bool vk_rshift = GetPrivateProfileInt(L"Nigero", L"vk_rshift", 0, inipath.c_str()) != 0;
	bool vk_rcontrol = GetPrivateProfileInt(L"Nigero", L"vk_rcontrol", 0, inipath.c_str()) != 0;
	bool vk_rmenu = GetPrivateProfileInt(L"Nigero", L"vk_rmenu", 0, inipath.c_str()) != 0;
	bool vk_space = GetPrivateProfileInt(L"Nigero", L"vk_space", 1, inipath.c_str()) != 0;

	nigero_setup(m_wndInvisible->GetSafeHwnd(), GetMyApplicationDataDir().c_str());
	nigero_enable();
	nigero_set_suppressor(VK_LSHIFT, vk_lshift);
	nigero_set_suppressor(VK_LCONTROL, vk_lcontrol);
	nigero_set_suppressor(VK_LMENU, vk_lmenu);
	nigero_set_suppressor(VK_RSHIFT, vk_rshift);
	nigero_set_suppressor(VK_RCONTROL, vk_rcontrol);
	nigero_set_suppressor(VK_RMENU, vk_rmenu);
	nigero_set_suppressor(VK_SPACE, vk_space);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

// CMainFrame ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG


