// AddAppDlg.cpp : t@C
//

#include "stdafx.h"
#include "AddAppDlg.h"
#include "InvisibleWnd.h"
#include <algorithm>

// based on http://homepage2.nifty.com/DSS/VCPP/API/PSAPI.htm

//
// EBhEnh EXE 擾
//
// HWND hWnd           : EBhEnh
// LPTSTR lpszFileName : tpXobt@
// DWORD nSize         : obt@ő咷
//
// return : BOOL : TRUE  : 
//                 FALSE : s
//
BOOL GetFileNameFromHwnd(HWND hWnd, LPTSTR lpszFileName, DWORD nSize)
{
    BOOL bResult = FALSE;
    DWORD dwProcessId;             // vZX ID
    GetWindowThreadProcessId(hWnd , &dwProcessId);

    // PSAPI ֐̃|C^
    BOOL (WINAPI *lpfEnumProcessModules)(HANDLE, HMODULE*, DWORD, LPDWORD);
    DWORD (WINAPI *lpfGetModuleFileNameEx)(HANDLE, HMODULE, LPTSTR, DWORD);

    // PSAPI.DLL Cu[h
    HINSTANCE hInstLib = LoadLibrary(L"PSAPI.DLL");
    if (hInstLib == NULL) {
        return FALSE;
    }

    // vV[W̃AhX擾
    (FARPROC &)lpfEnumProcessModules = GetProcAddress(hInstLib, "EnumProcessModules");
    (FARPROC &)lpfGetModuleFileNameEx = GetProcAddress(hInstLib, "GetModuleFileNameExW");

    if (lpfEnumProcessModules && lpfGetModuleFileNameEx) {
        // vZX̃nh擾
        HANDLE hProcess;
        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);
        if (hProcess) {
            // EXE W[̃nh擾
            HMODULE hModule;
            DWORD dwNeed;
            if (lpfEnumProcessModules(hProcess, &hModule, sizeof(hModule), &dwNeed)) {
                // W[nhtpX擾
                if (lpfGetModuleFileNameEx(hProcess, hModule, lpszFileName, nSize)) {
                    bResult = TRUE;
                }
            }
            // vZXIuWFNg̃nhN[Y
            CloseHandle(hProcess);
        }
    }

    // PSAPI.DLL CuJ
    FreeLibrary(hInstLib);

    return bResult;
}

// CAddAppDlg _CAO

IMPLEMENT_DYNAMIC(CAddAppDlg, CDialog)

BEGIN_MESSAGE_MAP(CAddAppDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, &CAddAppDlg::OnBnClickedButtonBrowse)
	ON_BN_CLICKED(IDOK, &CAddAppDlg::OnBnClickedOk)
	ON_LBN_DBLCLK(IDC_LIST1, &CAddAppDlg::OnLbnDblclkList1)
END_MESSAGE_MAP()

CAddAppDlg::CAddAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddAppDlg::IDD, pParent)
{

}

CAddAppDlg::~CAddAppDlg()
{
}

void CAddAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, _list_box);
}

void CAddAppDlg::UpdateListBox()
{
	_applications.clear();
	{
		HWND hWnd;
		hWnd = ::GetWindow(::GetDesktopWindow(), GW_CHILD);
		while (hWnd) {
			if (::IsWindowVisible(hWnd)) {
				wchar_t str[1000];
				::GetWindowText(hWnd, str, 1000);
				if (wcscmp(str, L"Nigero") != 0) {
					GetFileNameFromHwnd(hWnd, str, 1000);
					_applications.push_back(str);
				}
			}
			hWnd = ::GetWindow(hWnd, GW_HWNDNEXT);
		}
		if (!_applications.empty()) {
			std::sort(_applications.begin(), _applications.end());
			std::vector<std::wstring>::iterator it = std::unique(_applications.begin(), _applications.end());
			_applications.resize(it - _applications.begin());
		}
	}
	for (std::vector<std::wstring>::iterator it = _applications.begin(); it != _applications.end(); it++) {
		_list_box.AddString(it->c_str());
	}
}


void CAddAppDlg::OnBnClickedButtonBrowse()
{
	wchar_t path[MAX_PATH] = L"";
	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = *this;
	ofn.hInstance = 0;
	ofn.lpstrFilter = L"s\t@C(*.exe)\0*.exe\0" L"ׂẴt@C(*.*)\0*.*\0" L"\0";
	ofn.lpstrCustomFilter = 0;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = path;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = 0;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = 0;
	ofn.lpstrTitle = 0;
	ofn.Flags = OFN_FILEMUSTEXIST;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = 0;
	ofn.lCustData = 0;
	ofn.lpfnHook = 0;
	ofn.lpTemplateName = 0;

	if (!GetOpenFileName(&ofn)) {
		return;
	}

	_applications.clear();
	_applications.push_back(path);

	EndDialog(IDOK);
}

BOOL CAddAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	UpdateListBox();

	return TRUE;
}

void CAddAppDlg::OnBnClickedOk()
{
	std::vector<std::wstring> list;

	for (size_t i = 0; i < _applications.size(); i++) {
		if (_list_box.GetSel(i)) {
			list.push_back(_applications[i]);
		}
	}

	_applications = list;

	OnOK();
}

void CAddAppDlg::OnLbnDblclkList1()
{
	OnBnClickedOk();
}
